#include "algo.h"
extern int X,Y; 
extern Graph G;
extern double THRESHOLD;
struct val_index * vpart;
edgepart part;

#define sign(a)   (((a)>0)?1:-1)

int f11=0,f12=0,f21=0,f22=0;
double *W11;
double *W12;
double *W21;
double *W22;
int *L11;
int *L12;
int *L21;
int *L22;


void  EdgePartitions(Graph , int  );
int RobinsonFoulds(Graph , char *** , int * );
void ReturnLinkNeighbors( Graph , int , int * , int *, int *, int *, int * , int *, int * , int *, int *, int *);
void ComputePauplin(Graph , int , int , double , double * , double * , int * , int *);
void PrintNewickFormat( Graph , int ** , FILE* ); 
void Compute_Leaves_Dist_Topological ( Graph g , int ** d);
void build_family(Graph , int , int, int *,int * );
void compute_probabilities(Graph,int *, int *, int *,  int *, int *,  int *, int *,  int *);
double CalcolaLengthPauplin(Graph g, int **d);
void ComputeLeavesFromSite(Graph,int,int*,int*);
void compute_prob_node(Graph, int);
void assign_prob_nodes(Graph g,int root);
void compute_leaves_weights(Graph , int , int *, int *, double *);
void print_subtree(Graph, int);
int Compatibility();








//RESHAPE
void Reshape( int e, int s1, int s2, int s11, int s12, int s21, int s22,  int e11, int e12, int e21, int e22 ,int *count ) 
{

	int c,i,j;

	double d1112, d1121, d1122, d1221,d1222,d2122;
	double dA, dB, dC;
	double E1,E2,EIN;
	double norm11=0,norm12=0,norm21=0,norm22=0;
	
        
for( i = 0; i< G.nnodes; ++i ){
		G.Node[i].prob=0.;
                G.Node[i].weights[0]=1.;
                G.Node[i].weights[1]=1.;
		G.Node[i].sons[0]=-1;
                G.Node[i].sons[1]=-1;
		
	}

       norm11=0;norm12=0;norm21=0;norm22=0;
	f11=0,f12=0,f21=0,f22=0;
	build_family(G,s11,e11,L11,&f11);
	build_family(G,s12,e12,L12,&f12);
        build_family(G,s21,e21,L21,&f21);
        build_family(G,s22,e22,L22,&f22);
       
        

        compute_probabilities(G, &f11, L11, &f12, L12, &f21, L21, &f22, L22);
	compute_probabilities(G, &f12, L12, &f11, L11, &f21, L21, &f22, L22);
	compute_probabilities(G, &f21, L21, &f12, L12, &f11, L11, &f22, L22);
	compute_probabilities(G, &f22, L22, &f12, L12, &f21, L21, &f11, L11);
       
         assign_prob_nodes(G,s11);
         assign_prob_nodes(G,s12); 
         assign_prob_nodes(G,s21); 
         assign_prob_nodes(G,s22);        

        compute_leaves_weights(G,s11,&f11,L11,W11);
        compute_leaves_weights(G,s12,&f12,L12,W12);
        compute_leaves_weights(G,s21,&f21,L21,W21);
        compute_leaves_weights(G,s22,&f22,L22,W22);

	d1112 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f12; ++j )
			d1112 += W11[i]* W12[j] * G.leavesdist[L11[i]][L12[j]]*G.Node[L11[i]].prob*G.Node[L12[j]].prob;
	d1121 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f21; ++j )
			d1121 +=  W11[i]* W21[j] * G.leavesdist[L11[i]][L21[j]]*G.Node[L11[i]].prob*G.Node[L21[j]].prob;
	d1122 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f22; ++j )
			d1122 +=  W11[i]* W22[j] * G.leavesdist[L11[i]][L22[j]]*G.Node[L11[i]].prob*G.Node[L22[j]].prob;

	d1221 = 0;
	for( i = 0; i<f12; ++i )
		for( j = 0; j<f21; ++j )
			d1221 +=  W12[i]* W21[j] * G.leavesdist[L12[i]][L21[j]]*G.Node[L12[i]].prob*G.Node[L21[j]].prob;

	d1222 = 0;
	for( i = 0; i<f12; ++i )
		for( j = 0; j<f22; ++j )
			d1222 += W12[i]* W22[j] * G.leavesdist[L12[i]][L22[j]]*G.Node[L12[i]].prob*G.Node[L22[j]].prob;
	d2122 = 0;
	for( i = 0; i<f21; ++i )
		for( j = 0; j<f22; ++j )
			d2122 += W21[i]* W22[j] * G.leavesdist[L21[i]][L22[j]]*G.Node[L21[i]].prob*G.Node[L22[j]].prob;


	dA = d1112 + d2122;
	dB = d1121 + d1222;
	dC = d1122 + d1221;
	

	EIN= max(0, (dA - min(dB,dC)));
	E1 = max(0, (dB - min(dA,dC))); 
	E2 = max(0, (dC - min(dA,dB))); 

	if(EIN<E1 && EIN < E2)
		c=2;
	else {
		c=0;
		if(E2<E1)
			c=1;
	}



	*count=c;
		
switch ( c ) {
	case 0:
		G.Edge[e21].s1 = s1;
		G.Edge[e21].s2 = s21;
		G.Edge[e12].s1 = s2;
		G.Edge[e12].s2 = s12;
		G.Node[s1].neigh[0] = e;
		G.Node[s1].neigh[1] = e11;
		G.Node[s1].neigh[2] = e21;
		G.Node[s2].neigh[0] = e;
		G.Node[s2].neigh[1] = e12;
		G.Node[s2].neigh[2] = e22;
		break;
	case 1: 
		G.Edge[e22].s1 = s1;
		G.Edge[e22].s2 = s22;
		G.Edge[e12].s1 = s2;
		G.Edge[e12].s2 = s12;
		G.Node[s1].neigh[0] = e;
		G.Node[s1].neigh[1] = e11;
		G.Node[s1].neigh[2] = e22;
		G.Node[s2].neigh[0] = e;
		G.Node[s2].neigh[1] = e12;
		G.Node[s2].neigh[2] = e21;		
		break;
	case 2:
		break;
			
	default:
		fprintf(stderr,"only three cases (0,1,2)\n");
		exit(1);
	}
	

}
/*************************************************/


//assign_length_edge(assegnata secondo la BME)
void assign_external_edge( int e, int s1, int s2, int s11, int s12, int s21, int s22,  int e11, int e12, int e21, int e22)
{
int i,j;

	double d1112, d1121, d1122, d1221,d1222,d2122;
	double length;

	
	
        
for( i = 0; i< G.nnodes; ++i ){
		G.Node[i].prob=0.;
                G.Node[i].weights[0]=1.;
                G.Node[i].weights[1]=1.;
		G.Node[i].sons[0]=-1;
                G.Node[i].sons[1]=-1;
		
	}

  
	f11=0,f12=0,f21=0,f22=0;
	build_family(G,s11,e11,L11,&f11);
	build_family(G,s12,e12,L12,&f12);
        build_family(G,s21,e21,L21,&f21);
        build_family(G,s22,e22,L22,&f22);
       
        

        compute_probabilities(G, &f11, L11, &f12, L12, &f21, L21, &f22, L22);
	compute_probabilities(G, &f12, L12, &f11, L11, &f21, L21, &f22, L22);
	compute_probabilities(G, &f21, L21, &f12, L12, &f11, L11, &f22, L22);
	compute_probabilities(G, &f22, L22, &f12, L12, &f21, L21, &f11, L11);
       
         assign_prob_nodes(G,s11);
         assign_prob_nodes(G,s12); 
         assign_prob_nodes(G,s21); 
         assign_prob_nodes(G,s22);        

        compute_leaves_weights(G,s11,&f11,L11,W11);
        compute_leaves_weights(G,s12,&f12,L12,W12);
        compute_leaves_weights(G,s21,&f21,L21,W21);
        compute_leaves_weights(G,s22,&f22,L22,W22);

	d1112 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f12; ++j )
			d1112 += W11[i]* W12[j] * G.leavesdist[L11[i]][L12[j]]*G.Node[L11[i]].prob*G.Node[L12[j]].prob;
	d1121 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f21; ++j )
			d1121 +=  W11[i]* W21[j] * G.leavesdist[L11[i]][L21[j]]*G.Node[L11[i]].prob*G.Node[L21[j]].prob;
	d1122 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f22; ++j )
			d1122 +=  W11[i]* W22[j] * G.leavesdist[L11[i]][L22[j]]*G.Node[L11[i]].prob*G.Node[L22[j]].prob;

	d1221 = 0;
	for( i = 0; i<f12; ++i )
		for( j = 0; j<f21; ++j )
			d1221 +=  W12[i]* W21[j] * G.leavesdist[L12[i]][L21[j]]*G.Node[L12[i]].prob*G.Node[L21[j]].prob;

	d1222 = 0;
	for( i = 0; i<f12; ++i )
		for( j = 0; j<f22; ++j )
			d1222 += W12[i]* W22[j] * G.leavesdist[L12[i]][L22[j]]*G.Node[L12[i]].prob*G.Node[L22[j]].prob;
	d2122 = 0;
	for( i = 0; i<f21; ++i )
		for( j = 0; j<f22; ++j )
			d2122 += W21[i]* W22[j] * G.leavesdist[L21[i]][L22[j]]*G.Node[L21[i]].prob*G.Node[L22[j]].prob;


/*	int i,j;
	double dist;
        double d1112, d1121, d1122, d1221,d1222,d2122;
        double length=0;
	
 
	f11=0; f12=0; f21=0; f22=0;
	ComputePauplin(G, s11, e11 , 1 , &dist, W11 , L11, &f11);
	ComputePauplin(G, s12, e12 , 1 , &dist, W12 , L12, &f12);
	ComputePauplin(G, s21, e21 , 1 , &dist, W21 , L21, &f21);
	ComputePauplin(G, s22, e22,  1 , &dist, W22 , L22, &f22);


        d1112 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f12; ++j )
			d1112 +=  G.leavesdist[L11[i]][L12[j]]/W11[i]/W12[j];
	d1121 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f21; ++j )
			d1121 +=   G.leavesdist[L11[i]][L21[j]]/W11[i]/W21[j];
	d1122 = 0;
	for( i = 0; i<f11; ++i )
		for( j = 0; j<f22; ++j )
			d1122 += G.leavesdist[L11[i]][L22[j]]/W11[i]/W22[j];

	d1221 = 0;
	for( i = 0; i<f12; ++i )
		for( j = 0; j<f21; ++j )
			d1221 +=G.leavesdist[L12[i]][L21[j]]/W12[i]/W21[j];

	d1222 = 0;
	for( i = 0; i<f12; ++i )
		for( j = 0; j<f22; ++j )
			d1222 +=  G.leavesdist[L12[i]][L22[j]]/W12[i]/W22[j];
	d2122 = 0;
	for( i = 0; i<f21; ++i )
		for( j = 0; j<f22; ++j )
			d2122 +=  G.leavesdist[L21[i]][L22[j]]/W21[i]/W22[j];*/
 

       length=(1./4.)*(d1221+d1122+d1222+d1121)-(1./2.)*(d1112+d2122);

   
        G.Edge[e].dist = length;

}
/*************************************************/

//assign_length_edge(assegnata secondo la BME)
void assign_internal_edge( int e, int s11,int s21, int s22,int e21, int e22)
{

	int i,j;
	double dist;
        double d1122, d1121,d2122;
        double length=0;

for( i = 0; i< G.nnodes; ++i ){
		G.Node[i].prob=0.;
                G.Node[i].weights[0]=1.;
                G.Node[i].weights[1]=1.;
		G.Node[i].sons[0]=-1;
                G.Node[i].sons[1]=-1;
		
	}

	
        f21=0,f22=0;
	build_family(G,s21,e21,L21,&f21);
        build_family(G,s22,e22,L22,&f22);
       
        

	compute_probabilities(G, &f21, L21, &f12, L12, &f11, L11, &f22, L22);
	compute_probabilities(G, &f22, L22, &f12, L12, &f21, L21, &f11, L11);
       
 
         assign_prob_nodes(G,s21); 
         assign_prob_nodes(G,s22);        

  
        compute_leaves_weights(G,s21,&f21,L21,W21);
        compute_leaves_weights(G,s22,&f22,L22,W22);


	d1121 = 0;

		for( j = 0; j<f21; ++j )
			d1121 += W21[j] * G.leavesdist[s11][L21[j]]*G.Node[L21[j]].prob;
	d1122 = 0;

		for( j = 0; j<f22; ++j )
			d1122 += W22[j] * G.leavesdist[s11][L22[j]]*G.Node[L22[j]].prob;

	d2122 = 0;
	for( i = 0; i<f21; ++i )
		for( j = 0; j<f22; ++j )
			d2122 += W21[i]* W22[j] * G.leavesdist[L21[i]][L22[j]]*G.Node[L21[i]].prob*G.Node[L22[j]].prob;






/*	f21=0; f22=0;
	ComputePauplin(G, s21, e21 , 1 , &dist, W21 , L21, &f21);
	ComputePauplin(G, s22, e22,  1 , &dist, W22 , L22, &f22);



	d1121 = 0;

		for( j = 0; j<f21; ++j )
			d1121 +=G.leavesdist[s11][L21[j]]/W21[j];

	d1122 = 0;

		for( j = 0; j<f22; ++j )
			d1122 +=  G.leavesdist[s11][L22[j]]/W22[j];
	d2122 = 0;
	for( i = 0; i<f21; ++i )
		for( j = 0; j<f22; ++j )
			d2122 +=  G.leavesdist[L21[i]][L22[j]]/W21[i]/W22[j];*/
 

       length=(1./2.)*(d1121+d1122-d2122);

   
        G.Edge[e].dist = length;

}
/*************************************************/


//PERMUT
void permut(int num, int *perm){

	int count,index,temp;
	count=num-2;
	while (count>=0){
		index=FRANDOM*count;
		temp=perm[count+1];
		perm[count+1]=perm[index];
		perm[index]=temp;
		count--;
	} 


}
/*************************************************/





//FIND_CHERRIES
void find_cherries( int s11, int e11) 
{

	int i;


	
        
for( i = 0; i< G.nnodes; ++i ){
		G.Node[i].prob=0.;
                G.Node[i].weights[0]=1.;
                G.Node[i].weights[1]=1.;
		G.Node[i].sons[0]=-1;
                G.Node[i].sons[1]=-1;
		
	}

    f11=0;
	build_family(G,s11,e11,L11,&f11);

       
        

 

if(f11==2){
X=L11[0];
Y=L11[1];
}


}
/*************************************************/






//MC
void Mc( char *nomegrafo)
{
	int i,j, ** disttopo,*perm;
	int edge,edge1,edge2,c,countc,index;
	int s1, s2, s3,s11, s12, s21, s22,count;
	int e11,e12,e21,e22;
	FILE *fpgrafo;



	W11 = (double *) malloc (G.nleaves * sizeof ( double ) );
	W12 = (double *) malloc (G.nleaves * sizeof ( double ) );
	W21 = (double *) malloc (G.nleaves * sizeof ( double ) );
	W22 = (double *) malloc (G.nleaves * sizeof ( double ) );

	L11 = (int *) malloc (G.nleaves * sizeof ( int ) );
	L12 = (int *) malloc (G.nleaves * sizeof ( int ) );
	L21 = (int *) malloc (G.nleaves * sizeof ( int ) );
	L22 = (int *) malloc (G.nleaves * sizeof ( int ) );

        
	
	
	
	
	perm = (int *) malloc (G.internaledge.size * sizeof ( int ) );
	for( i =0; i<G.internaledge.size; ++i){
		perm[i]=i;
	}




      fpgrafo = fopen ( nomegrafo, "w" ) ;

        if ( fpgrafo == NULL ) {
                fprintf(stderr, "grafo output file  %s doesn't exist ... exiting\n", nomegrafo );
                exit(-1);
        }


	disttopo = (int ** ) malloc ( G.nleaves * sizeof( int * ) );


	for( i = 0; i< G.nleaves; ++i ){
		disttopo[i] = (int *) malloc ( G.nleaves * sizeof( int ));
	}

	for( i=G.nleaves; i< G.nnodes ; i ++){
		G.Node[i].labelnewick = (char * ) malloc (500000 * sizeof ( char ) );
	}




for( j = 0 ; j<100; ++j ){
		

		countc=0;
		for( i =0; i<G.internaledge.size; ++i){
			
			index=perm[i];
			edge = G.internaledge.vec[index];
			ReturnLinkNeighbors( G,edge, &s1, &s2, &s11, &s12, &s21, &s22,&e11,&e12,&e21,&e22);
			
			Reshape(edge, s1, s2,  s11, s12, s21, s22,e11,e12,e21,e22,&c);
			if(c!=2) countc++;
		}
		
		if(!countc) break;
		permut(G.internaledge.size,perm);
	}

			//find a couple of cherries leaves

                      for( i =0; i<G.internaledge.size; ++i){
			
			index=perm[i];
			edge = G.internaledge.vec[index];
			ReturnLinkNeighbors( G,edge, &s1, &s2, &s11, &s12, &s21, &s22,&e11,&e12,&e21,&e22);
			
			find_cherries(s11, e11);
                        find_cherries(s12, e12);
                        find_cherries(s21, e21);
                        find_cherries(s22, e22);
			
		       }
			//assign length to internal edges 
                        for( i =0; i<G.internaledge.size; ++i){
			
			index=perm[i];
			edge = G.internaledge.vec[index];
                        ReturnLinkNeighbors( G,edge, &s1, &s2, &s11, &s12, &s21, &s22,&e11,&e12,&e21,&e22);
			assign_external_edge(edge, s1, s2,  s11, s12, s21, s22,e11,e12,e21,e22);
			}

			//assign length to external edges
			for( i =0; i<G.nleaves; ++i){
			edge = G.Node[i].neigh[0];
                        s1=G.Edge[edge].s1;
                        if(G.Edge[edge].s1==i)s1=G.Edge[edge].s2;
                        assert(s1 != i);
                          count=0;
                          for( j = 0; j<G.nedges; ++j ){
		          if(G.Edge[j].s1==s1  && j!=edge){
 						if(count==0){edge1=j;
                                                            s2=G.Edge[j].s2;}
                                                if(count==1){edge2=j;
                                                             s3=G.Edge[j].s2;}
                                                 count++;
                                                 }
       
							 
                          if(G.Edge[j].s2==s1  && j!=edge){
 						if(count==0){edge1=j;
                                                            s2=G.Edge[j].s1;}
                                                if(count==1){edge2=j;
                                                             s3=G.Edge[j].s1;}
                                                 count++;
                                                 }
       
							}
            
                          assert(count==2);
                          assign_internal_edge( edge, i,s2, s3,edge1, edge2);
						}

                        
 	PrintNewickFormat( G,disttopo,fpgrafo ); 



	free( W11);
	free( W12);
	free( W21);
	free( W22);
	free( L11);
	free( L12);
	free( L21);
	free( L22);

       
	for( i = 0; i< G.nleaves; ++i ){
		free(disttopo[i]);
	}
	free(disttopo);
}
/*************************************************/
